/*
=============================================================================
*	Pequeo ejemplo para el uso del SD Frontal de Wii						*
*																			*
*	AUTOR: Ti-Ra-Nog														*
=============================================================================
*																			*
*  This program is free software; you can redistribute it and/or modify		*
*  it under the terms of the GNU General Public License version 2			*
*  as published by the Free Software Foundation								*
*																			*
*  This program is distributed in the hope that it will be useful,			*
*  but WITHOUT ANY WARRANTY; without even the implied warranty of			*
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
*  GNU General Public License for more details.								*
*																			*
=============================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
//#include <math.h>
#include <ogcsys.h>
#include <gccore.h>
//#include <ogc/ios.h>

// Wiimote lib
//#include "wiiuse.h"

// Wii Front SD lib
#include "sdio.h"
#include "tff.h"

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

//wiimote** wiimotes;
int inicio;//, errror;
#define MAX_WIIMOTES				1
#define DIRECTORIO	"elf"
#define ARCHIVO	"elf/texto.txt"
//unsigned int irx=0,iry=0;
//unsigned int buttonB=0, buttonA=0, buttonUP=0, buttonDOWN=0, buttonLEFT=0, buttonRIGHT=0;

/* Debug reload()
void reload(){
	while(0){
		if (errror==0){
		printf("\n\n-->ERROR<-\n\n");
		errror=1;
		}
	}
}*/


//Usar boton Reset
static vu32* const _piReg = (u32*)0xCC003000;

static __inline__ u32 __sys_getresetbuttonraw()
{
	return (!(_piReg[0]&0x00010000));
}

void (*reload)() = (void (*) ()) 0x80001800;

/* Obvio no? xD
void wiimote_event(struct wiimote_t* wm, int event) {
	switch (event) {
	
		case WIIUSE_EVENT:
		
			buttonB=0;

			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_B))
				buttonB=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_A))
				buttonA=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_UP))
				buttonUP=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_DOWN))
				buttonDOWN=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_LEFT))
				buttonLEFT=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_RIGHT))
				buttonRIGHT=1;
			break;
		
		default:
			break;
	}
}*/


void load_file(){

	FATFS ffs;
	DIR dir;
	FILINFO finfo;
	s32 ret;
	FIL fp;
	char filelist[999][13];
	u32 files;
	int i;

	files = 0;

	printf("[*] Montando SD Frontal... ");
	
	ret = f_mount(0, &ffs); // Montar la SD frontal, si no puede --> error.
	if (ret != FR_OK) {
		printf("f_mount() fall. La SD est formateada en FAT?\n");
		printf("(ret = %d)\n\n", ret);
		printf("Se volver al loader en 5 segundos.\n");
		usleep(5000000);
		reload();
		
	}
	printf(" OK!\n"); // Ha conseguido motarla.

	printf("[*] Abriendo directorio: \"%s\"...", DIRECTORIO);
	fflush(stdout);

	ret = f_opendir(&dir, DIRECTORIO); // Abrir directorio "x", si no puede --> error.
	if (ret != FR_OK) {
		printf("\nError! (ret = %d)\n\n", ret);
		printf("Se volver al loader en 5 segundos.\n");
		usleep(5000000);
		reload();
	}
	printf(" OK!\n"); // Ha conseguido abrir el directorio.

	/* Read directory */
	while ((f_readdir(&dir, &finfo) == FR_OK) && finfo.fname[0]) {
		if(!(finfo.fattrib & AM_DIR)) // Hacer hasta dejar de encontrar ficheros en la carpeta "x".
		{
			//printf("Aadiendo %s\n", finfo.fname); // No funciona bien, mejor hacerlo fuera xD.
			memcpy(filelist[files++], finfo.fname, 13); // Aade el nombre del fichero a la variable "filelist".
		}
	}
	printf("\nContenido del directorio:\n");
	for(i=0; i<files; i++){
		printf("\n%s",filelist[i]); // Muestra en pantalla el nombre de todos los ficheros en el directorio "x".
	}
	
	printf("\n\n[*] Abriendo \"%s\"...", ARCHIVO);
		
	if(f_stat(ARCHIVO, &finfo) != FR_OK) // Revisa si existe susodicho archivo, si no --> error.
		{
			printf("\nerror: f_stat() fall :/\n");
			printf("Se volver al loader en 5 segundos.\n");
			usleep(5000000);
			reload();
		}
	if(f_open(&fp, ARCHIVO, FA_READ) != FR_OK) // Abre el archivo en cuestin, si no --> error.
		{
			printf("\nerror: f_open() fall\n");
			printf("Se volver al loader en 5 segundos.\n");
			usleep(5000000);
			reload();
		}
	printf("\n[*] Leyendo %u bytes...\n", (unsigned int)finfo.fsize); // Mostrar tamao del archivo.
	printf("\nContenido del fichero:\n\n");
	usleep(5000000);
	while (0){ 
		// Aqu se tendria que poner la rutina para imprimir en pantalla el contenido del archivo, pero ya es tarde y tengo sueo jeje, si alguien se ve con ganas de hacerlo ADELANTE!!.
	}

	
}


void load_menu()
{

	while(1)
	{
		VIDEO_Flush();
		VIDEO_WaitVSync();
		if(__sys_getresetbuttonraw()) reload();//Si se pulsa el boton de reset se reinicia el loader
		//if(buttonB=1) reload(); //Si se pulsa el boton B del WiiMote se reinicia el loader
	}
}



int main(){
	
	// Iniciar VIDEO
	VIDEO_Init();
	PAD_Init();
	
	switch(VIDEO_GetCurrentTvMode()) {
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	
	
	// Imprimir Info sobre el programilla
	printf("\n\nSD-Front TEST By Ti-Ra-Nog\n");
	printf("==========================\n\n");
	//printf("Presiona 1 y 2 en tu WiiMote Por Favor\n\n");
	VIDEO_Flush();
	VIDEO_WaitVSync();
/*
	*((u32*)0xcd0000c0) |= 0x100;
	bte_init();
	bte_start();
	wiimotes =  wiiuse_init(MAX_WIIMOTES, wiimote_event);
	wiiuse_find(wiimotes, MAX_WIIMOTES, 5);
	wiiuse_connect(wiimotes, MAX_WIIMOTES);
	wiiuse_set_leds(wiimotes[0], WIIMOTE_LED_1);
	wiiuse_rumble(wiimotes[0], 1);
	usleep(200000); // 200ms 
	wiiuse_rumble(wiimotes[0], 0);
	wiiuse_set_ir(wiimotes[0], 0);
	usleep(200000); // 200ms 
	wiiuse_motion_sensing(wiimotes[0], 0);*/
	
	//iniciar funciones
	load_file(); // Funcin principal ->Cargar Archivo<-
	load_menu(); // Funcin Secundaria ->Iniciar Men<-




return(0);

}
